/************** BEST VIEWED IN A CODE EDITOR 80 COLUMNS WIDE *******************
*
* ToughBuilt ClipTech Mount
* Benjamen Johnson <workshop.electronsmith.com>
* 20201108
*
* openSCAD Version: 2019.05 
* Licesnse: Creative Commons - Attribution - Share Alike
*           https://creativecommons.org/licenses/by-sa/4.0/
*******************************************************************************/
/*[Hidden]*/
version = "V1_0";

/*[Edit Me]*/
/*******************************************************************************
*
*******************************************************************************/
// Wat do you want the label to say?
label = "TAPS & DIES";

// How big you want the text
font_size = 11;//[0:0.5:15]

// Adjust the length of the label
length_adjust = 1; //[0.95:0.01:1.05]

// Adjust how tight the catch is
catch_adjust = 1; //[0.95:0.01:1.05]

/*[Label Parameters]*/
/*******************************************************************************
* 
*******************************************************************************/
// Length of the base (face of the handle)
base_length = 117;

adj_base_len = base_length * length_adjust;

// Width of the base (face of the handle)
base_width = 18;

// Height of the base (thickness of the label)
base_height = 3;

// create vector for defining the base
BASE_DEF = [adj_base_len,base_width,base_height];

// How wide the catch should be
catch_length = 8.5;

// How hight the catch should be
catch_height = 7;

// Diameter of catch pocket
catch_dia = 3;

adj_catch_dia = catch_dia * catch_adjust;

// figure out where the end of the label will be
end_pos = (adj_base_len+2*base_height)/2;

// create vectos for defining the catch and catch position
CATCH_DEF = [catch_length,base_width,catch_height];
CATCH_POS = [-end_pos,0,-catch_height/2+base_height];

CATCH_CUT_POS = [-adj_base_len/2+adj_catch_dia/2,0,-adj_catch_dia/2];

/*[Label Options]*/
/*******************************************************************************
* Label Options
*******************************************************************************/
// Which font do you want to use
font_style = "ARIAL";

// How thick the font is (back to front)
font_thickness = 0.6;

/*[Hidden]*/
/*******************************************************************************
* Important definitions
*******************************************************************************/
INVERT_X =[[-1,0,0],[0,1,0],[0,0,1]];
INVERT_Y =[[1,0,0],[0,-1,0],[0,0,1]];

$dl= 0.01;

/*******************************************************************************
* Make the label
*******************************************************************************/
//define chamfers
LONG_CHAMFER_DEF = [2*end_pos,base_height*sqrt(2),10];
LONG_CHAMFER_POS = [0,base_width/2,base_height];

difference(){
    union(){
        translate([0,0,base_height/2])
        cube(BASE_DEF,center = true);
    
        translate(CATCH_POS)
        cube(CATCH_DEF,center=true);
       
        translate(INVERT_X * CATCH_POS)
        cube(CATCH_DEF,center=true);
    } //end union
    
    //chamfer long edges
    translate(LONG_CHAMFER_POS)
    rotate([45,0,0])
    cube(LONG_CHAMFER_DEF,center = true);
    
    translate(INVERT_Y*LONG_CHAMFER_POS)
    rotate([-45,0,0])
    cube(LONG_CHAMFER_DEF,center = true);
    
    //chamfer top ends
    translate([-end_pos-3*sqrt(2),0,base_height])
    rotate([0,45,0])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);
    
    translate([end_pos+3*sqrt(2),0,base_height])
    rotate([0,-45,0])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);
    
    // chamfer bottom ends
    translate([end_pos+3*sqrt(2)+2,0,-base_height])
    rotate([0,45,0])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);
    
    translate([-end_pos-3*sqrt(2)-2,0,-base_height])
    rotate([0,-45,0])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);
    
    // chamfer corners
    corner_cut = 1.3;
    translate([-end_pos-3*sqrt(2)-corner_cut,base_width/2,base_height])
    rotate([0,0,-45])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);

    translate([-end_pos-3*sqrt(2)-corner_cut,-base_width/2,base_height])
    rotate([0,0,45])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);

    translate([end_pos+3*sqrt(2)+corner_cut,base_width/2,base_height])
    rotate([0,0,45])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);

    translate([end_pos+3*sqrt(2)+corner_cut,-base_width/2,base_height])
    rotate([0,0,-45])
    cube([base_height*sqrt(2)+2*3,base_width+10,20],center = true);

    // make cutout for the catches
    translate(CATCH_CUT_POS)
    rotate([90,0,0])
    cylinder(d = adj_catch_dia,h = base_width+$dl,$fn=20,center = true);
    
    translate(INVERT_X * CATCH_CUT_POS)
    rotate([90,0,0])
    cylinder(d = adj_catch_dia,h = base_width+$dl,$fn=20,center = true);
}// end difference

// add the label text
translate([0,0,base_height])
color("white")
linear_extrude(height = font_thickness)
    text(text = label, font = font_style, size = font_size, valign="center",halign = "center");

